---
title: USB
slug: Web/API/USB
tags:
  - API
  - Interface
  - Reference
  - USB
  - WebUSB
  - WebUSB API
---
<p>{{APIRef("WebUSB API")}}{{SeeCompatTable}}{{securecontext_header}}</p>

<p>The <strong><code>USB</code></strong> interface of the <a href="/en-US/docs/Web/API/WebUSB_API">WebUSB API</a> provides attributes and methods for finding and connecting USB devices from a web page.</p>

<h2 id="Properties">Properties</h2>

<p>None.</p>

<h3 id="Event_handlers">Event handlers</h3>

<dl>
 <dt>{{domxref("USB.onconnect")}}</dt>
 <dd>An event handler called whenever a previously paired device is connected.</dd>
 <dt>{{domxref("USB.ondisconnect")}}</dt>
 <dd>An event handler called whenever a paired device is disconnected.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("USB.getDevices()")}}</dt>
 <dd>Returns a {{jsxref("Promise")}} that resolves with an array of {{domxref("USBDevice")}} objects for paired attached devices.</dd>
 <dt>{{domxref("USB.requestDevice()")}}</dt>
 <dd>Returns a {{jsxref("Promise")}} that resolves with an instance of {{domxref("USBDevice")}} if the specified device is found. Calling this function triggers the user agent's pairing flow.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web USB','#enumeration','USB')}}</td>
   <td>{{Spec2('Web USB')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.USB")}}</p>
